#include <stdio.h>
#include <iostream>

using namespace std;

long long int deo=1;
long long int suma=0;
long long int tempo;
int a[20000004];
int b[100004];
int main()
{
    int n,m,c;
    scanf("%d %d", &n, &m);
    for(int i=1; i<=n; i++)
        {a[i]=i;}
    for(int i=1; i<=m; i++)
       {scanf("%d", &b[i]);}
    scanf("%d", &c);
    for(int i=0; i<=n-m; i++)
    {
        for(int j=1; j<=m; j++)
            a[i+b[j]]=a[i+j];
    }
    for(int i=1; i<=n; i++)
    {
        deo=deo*c;
        deo=deo%998244353;
        tempo=deo*a[i];
        tempo=tempo%998244353;
        suma+=tempo;
        suma=suma%998244353;
    }
    printf("%d", suma);
}